Package net.sf.saxon.tree.iter

## Class TextLinesIterator

- java.lang.Object
- - net.sf.saxon.tree.iter.TextLinesIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `SequenceIterator`
  Direct Known Subclasses:
    `UnparsedTextIterator`

      public abstract class TextLinesIterator
      extends java.lang.Object
      implements SequenceIterator

  An iterator that iterates over a file line by line, returning each line as a `StringValue`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected java.util.function.IntPredicate` | `checker` |
    `protected Location` | `location` |
    `protected java.io.LineNumberReader` | `reader` |
    `protected java.net.URI` | `uri` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `TextLinesIterator()` |
    `` | `TextLinesIterator​(java.io.LineNumberReader reader, Location location, java.net.URI uri, java.util.function.IntPredicate checker)` | Create a TextLinesIterator over a given reader

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the iterator.
    `StringValue` | `next()` | Get the next item in the sequence.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `forEachOrFail, getProperties, materialize`

- - ### Field Detail

    - #### reader

          protected java.io.LineNumberReader reader

    - #### checker

          protected java.util.function.IntPredicate checker

    - #### location

          protected Location location

    - #### uri

          protected java.net.URI uri

  - ### Constructor Detail

    - #### TextLinesIterator

          protected TextLinesIterator()

    - #### TextLinesIterator

          public TextLinesIterator​(java.io.LineNumberReader reader,
                                   Location location,
                                   java.net.URI uri,
                                   java.util.function.IntPredicate checker)
                            throws XPathException

      Create a TextLinesIterator over a given reader
      Parameters:
        `reader` - the reader that reads the file
        `checker` - checks that the characters in the file are legal XML characters
        `location` - the location of the instruction being executed, for diagnostics. May be null.
        `uri` - the URI of the file being read, for diagnostics
      Throws:
        `XPathException` - if a dynamic error occurs

  - ### Method Detail

    - #### next

          public StringValue next()
                           throws XPathException

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator.
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      For example, the iterator returned by the unparsed-text-lines() function has a close() method that causes the underlying input stream to be closed, whether or not the file has been read to completion.

      Closing an iterator is important when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `SequenceIterator`